searchNodes=[{"ref":"Uploadex.html","title":"Uploadex","type":"module","doc":"Context Helper functions for handling files."},{"ref":"Uploadex.html#create_with_file/2","title":"Uploadex.create_with_file/2","type":"function","doc":"Inserts the changeset and store the record files in a database transaction, so if the files fail to be stored the record will not be created."},{"ref":"Uploadex.html#delete_with_file/2","title":"Uploadex.delete_with_file/2","type":"function","doc":"Deletes the record and all of its files. This is not in a database transaction, since the delete operation never returns errors."},{"ref":"Uploadex.html#update_with_file/3","title":"Uploadex.update_with_file/3","type":"function","doc":"Updates the record and its files in a database transaction, so if the files fail to be stored the record will not be created. This function also deletes files that are no longer referenced."},{"ref":"Uploadex.html#update_with_file_keep_previous/2","title":"Uploadex.update_with_file_keep_previous/2","type":"function","doc":"Similar to update_with_file/3, but does not delete previous files."},{"ref":"Uploadex.FileProcessing.html","title":"Uploadex.FileProcessing","type":"module","doc":"Process files in Base64"},{"ref":"Uploadex.FileProcessing.html#process_binary/1","title":"Uploadex.FileProcessing.process_binary/1","type":"function","doc":"If it&#39;s in base64, decode it. Otherwise, do not try to process the file."},{"ref":"Uploadex.FileStorage.html","title":"Uploadex.FileStorage","type":"module","doc":"Storage for Local Files. Opts directory: String (required for all functions) - Relative to base_path base_path: String (required for all functions) base_url: String (required for Uploadex.Storage.get_url/2) To build the URL, base_path will be replaced by base_url. Example To use this storage for your User record, define these functions in your Uploadex.Uploader implementation: def default_opts(Uploadex.FileStorage), do: [base_path: :code.priv_dir(:my_app), base_url: Endpoint.url()] def storage(%User{} = user), do: {Uploadex.FileStorage, directory: &quot;/uploads/users&quot;}"},{"ref":"Uploadex.FileStorage.html#delete_file_after_delay/2","title":"Uploadex.FileStorage.delete_file_after_delay/2","type":"function","doc":""},{"ref":"Uploadex.Files.html","title":"Uploadex.Files","type":"module","doc":"Functions to store and delete files."},{"ref":"Uploadex.Files.html#delete_files/1","title":"Uploadex.Files.delete_files/1","type":"function","doc":"Deletes all files for a record."},{"ref":"Uploadex.Files.html#delete_previous_files/2","title":"Uploadex.Files.delete_previous_files/2","type":"function","doc":"Deletes all files that changed."},{"ref":"Uploadex.Files.html#get_file_url/3","title":"Uploadex.Files.get_file_url/3","type":"function","doc":""},{"ref":"Uploadex.Files.html#get_files_url/2","title":"Uploadex.Files.get_files_url/2","type":"function","doc":""},{"ref":"Uploadex.Files.html#get_files_url/3","title":"Uploadex.Files.get_files_url/3","type":"function","doc":""},{"ref":"Uploadex.Files.html#get_temporary_file/4","title":"Uploadex.Files.get_temporary_file/4","type":"function","doc":""},{"ref":"Uploadex.Files.html#get_temporary_files/3","title":"Uploadex.Files.get_temporary_files/3","type":"function","doc":""},{"ref":"Uploadex.Files.html#get_temporary_files/4","title":"Uploadex.Files.get_temporary_files/4","type":"function","doc":""},{"ref":"Uploadex.Files.html#store_files/1","title":"Uploadex.Files.store_files/1","type":"function","doc":"Stores all files of a record, as defined by the uploader. Files that are not maps are ignored, which allows for assigning an existing file to a record without recreating it, by simply passing it&#39;s filename."},{"ref":"Uploadex.Files.html#t:record/0","title":"Uploadex.Files.record/0","type":"type","doc":""},{"ref":"Uploadex.Files.html#t:record_field/0","title":"Uploadex.Files.record_field/0","type":"type","doc":""},{"ref":"Uploadex.Resolver.html","title":"Uploadex.Resolver","type":"module","doc":"Resolver functions to make it easier to use Uploadex with Absinthe. Example In your Absinthe schema, assuming user only has one photo: object :user do field :photo_url, :string, resolve: &amp;Uploadex.Resolver.get_file_url/3 end If it has many photos: object :user do field :photos, list_of(:string), resolve: &amp;Uploadex.Resolver.get_files_url/3 end If an object has many files but the field is for a specific one: object :company do field :logo_url, :string, resolve: fn company, _, _ -&gt; Uploadex.Resolver.get_file_url(company, company.logo) end end"},{"ref":"Uploadex.Resolver.html#get_file_url/1","title":"Uploadex.Resolver.get_file_url/1","type":"function","doc":""},{"ref":"Uploadex.Resolver.html#get_file_url/3","title":"Uploadex.Resolver.get_file_url/3","type":"function","doc":""},{"ref":"Uploadex.Resolver.html#get_files_url/1","title":"Uploadex.Resolver.get_files_url/1","type":"function","doc":""},{"ref":"Uploadex.Resolver.html#get_files_url/3","title":"Uploadex.Resolver.get_files_url/3","type":"function","doc":""},{"ref":"Uploadex.S3Storage.html","title":"Uploadex.S3Storage","type":"module","doc":"Storage for AWS S3. Opts bucket: String (required for all functions) region: String (required for Uploadex.Storage.get_url/2) directory: String (required for all functions) upload_opts: Keyword list. This opts are passed to ExAws.S3.upload/4 and ExAws.S3.put_object/4 (required for Uploadex.Storage.store/2) Example To use this storage for your User record, define these functions in your Uploadex.Uploader implementation: def default_opts(Uploadex.S3Storage), do: [bucket: &quot;my_bucket&quot;, region: &quot;sa-east-1&quot;, upload_opts: [acl: :public_read]] def storage(%User{} = user), do: {Uploadex.S3Storage, directory: &quot;/photos&quot;}"},{"ref":"Uploadex.S3Storage.html#delete_file_after_delay/2","title":"Uploadex.S3Storage.delete_file_after_delay/2","type":"function","doc":""},{"ref":"Uploadex.Storage.html","title":"Uploadex.Storage","type":"behaviour","doc":"Behaviour for a Storage implementation."},{"ref":"Uploadex.Storage.html#c:delete/2","title":"Uploadex.Storage.delete/2","type":"callback","doc":"Deletes the file"},{"ref":"Uploadex.Storage.html#c:get_temporary_file/3","title":"Uploadex.Storage.get_temporary_file/3","type":"callback","doc":"Returns the path of a temporary file, that will be deleted after the configured amount of time."},{"ref":"Uploadex.Storage.html#c:get_url/2","title":"Uploadex.Storage.get_url/2","type":"callback","doc":"Returns the file&#39;s URL"},{"ref":"Uploadex.Storage.html#c:store/2","title":"Uploadex.Storage.store/2","type":"callback","doc":"Stores the file"},{"ref":"Uploadex.Storage.html#t:file/0","title":"Uploadex.Storage.file/0","type":"type","doc":""},{"ref":"Uploadex.Storage.html#t:opts/0","title":"Uploadex.Storage.opts/0","type":"type","doc":""},{"ref":"Uploadex.Storage.html#t:record/0","title":"Uploadex.Storage.record/0","type":"type","doc":""},{"ref":"Uploadex.TestStorage.html","title":"Uploadex.TestStorage","type":"module","doc":"Storage for tests. See files_test.exs for examples on how to use this."},{"ref":"Uploadex.TestStorage.html#child_spec/1","title":"Uploadex.TestStorage.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Uploadex.TestStorage.html#get_deleted/0","title":"Uploadex.TestStorage.get_deleted/0","type":"function","doc":""},{"ref":"Uploadex.TestStorage.html#get_opts/0","title":"Uploadex.TestStorage.get_opts/0","type":"function","doc":""},{"ref":"Uploadex.TestStorage.html#get_stored/0","title":"Uploadex.TestStorage.get_stored/0","type":"function","doc":""},{"ref":"Uploadex.TestStorage.html#start_link/1","title":"Uploadex.TestStorage.start_link/1","type":"function","doc":""},{"ref":"Uploadex.Upload.html","title":"Uploadex.Upload","type":"module","doc":"Ecto type that handles upload. It stores the filename in the database."},{"ref":"Uploadex.Upload.html#t:upload_binary/0","title":"Uploadex.Upload.upload_binary/0","type":"type","doc":""},{"ref":"Uploadex.Upload.html#t:upload_path/0","title":"Uploadex.Upload.upload_path/0","type":"type","doc":""},{"ref":"Uploadex.Uploader.html","title":"Uploadex.Uploader","type":"behaviour","doc":"Behaviour of an Uploader. Example defmodule MyApp.Uploader do @moduledoc false @behaviour Uploadex.Uploader alias MyAppWeb.Endpoint @impl true def get_fields(%User{}), do: :photo def get_fields(%Company{}), do: [:photo] @impl true def default_opts(Uploadex.FileStorage), do: [base_path: :code.priv_dir(:my_app), base_url: Endpoint.url()] def default_opts(Uploadex.S3Storage), do: [bucket: &quot;my_bucket&quot;, region: &quot;sa-east-1&quot;, upload_opts: [acl: :public_read]] @impl true def storage(%User{id: id}, :photo), do: {Uploadex.FileStorage, directory: &quot;/uploads/users/\#{id}&quot;} def storage(%Company{}, :photo), do: {Uploadex.S3Storage, directory: &quot;/thumbnails&quot;} # Optional: @impl true def accepted_extensions(%User{}, _field), do: ~w(.jpg .png) def accepted_extensions(_any, _any), do: :any end"},{"ref":"Uploadex.Uploader.html#c:accepted_extensions/2","title":"Uploadex.Uploader.accepted_extensions/2","type":"callback","doc":""},{"ref":"Uploadex.Uploader.html#c:default_opts/1","title":"Uploadex.Uploader.default_opts/1","type":"callback","doc":""},{"ref":"Uploadex.Uploader.html#c:get_fields/1","title":"Uploadex.Uploader.get_fields/1","type":"callback","doc":""},{"ref":"Uploadex.Uploader.html#c:storage/2","title":"Uploadex.Uploader.storage/2","type":"callback","doc":""},{"ref":"Uploadex.Uploader.html#t:file/0","title":"Uploadex.Uploader.file/0","type":"type","doc":""},{"ref":"Uploadex.Uploader.html#t:record/0","title":"Uploadex.Uploader.record/0","type":"type","doc":""},{"ref":"Uploadex.Uploader.html#t:record_field/0","title":"Uploadex.Uploader.record_field/0","type":"type","doc":""}]